/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.task.factory;

import nl.cloudfarming.client.task.Task;

/**
 *
 * @author Maciek Dulkiewicz <maciek.dulkiewicz@ordina.nl>
 */
public interface TaskObjectFactory {
    
    boolean canCreate(Class clazz);
    
    /**
     * SelectionModes, for example: ListSelectionModel.SINGLE_SELECTION or 
     * ListSelectionModel.SINGLE_INTERVAL_SELECTION or 
     * ListSelectionModel.MULTIPLE_INTERVAL_SELECTION.
     * Specifies how selection of the items for this task should work. 
     * Use for example ListSelectionModel.SINGLE_SELECTION if you want to make a single selection, such as only 1 field.
     * 
     * @param task Task to create item(s) for
     * @param selectionMode SelectionMode as described above.
     * @return 
     */
    Object create(Task task, int selectionMode);
}
