/**
 * Copyright (C) 2008-2012 AgroSense Foundation.
 *
 * AgroSense is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * There are special exceptions to the terms and conditions of the GPLv3 as it is applied to
 * this software, see the FLOSS License Exception
 * <http://www.agrosense.eu/foss-exception.html>.
 *
 * AgroSense is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with AgroSense.  If not, see <http://www.gnu.org/licenses/>.
 */
package nl.cloudfarming.client.task.windows;

import java.awt.BorderLayout;
import java.awt.Color;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JLabel;
import nl.cloudfarming.client.task.Task;
import nl.cloudfarming.client.util.swing.FormRow;

/**
 *
 * @author Timon Veenstra <monezz@gmail.com>
 */
public class TaskStatePanel extends javax.swing.JPanel {

    public TaskStatePanel() {
//        initComponents();
        init();
        setBackground(Color.WHITE);
    }

    /**
     * Creates new form TaskStatePanel
     */
    public TaskStatePanel(final Task task) {
        this();
        setTask(task);
    }
    private void init() {
        setLayout(new BorderLayout());
        stateValue = new javax.swing.JLabel();
        add(new FormRow(false, org.openide.util.NbBundle.getMessage(TaskStatePanel.class, "TaskStatePanel.stateLabel.text"), "", stateValue));
    }

    public void setTask(final Task task) {
        task.addPropertyChangeListener(new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent evt) {
                if (Task.PROP_STATUS.equals(evt.getPropertyName())) {
                    updateStatus(task);
                }
            }
        });
        updateStatus(task);

    }

    private void updateStatus(Task task) {
        if (task.isComplete()) {
            stateValue.setForeground(Color.GREEN);
            stateValue.setText("complete");
        } else {
            stateValue.setForeground(Color.RED);
            stateValue.setText("incomplete");
        }
    }

    public JLabel getStateValue() {
        return stateValue;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        stateLabel = new javax.swing.JLabel();
        stateValue = new javax.swing.JLabel();

        org.openide.awt.Mnemonics.setLocalizedText(stateLabel, org.openide.util.NbBundle.getMessage(TaskStatePanel.class, "TaskStatePanel.stateLabel.text")); // NOI18N

        org.openide.awt.Mnemonics.setLocalizedText(stateValue, org.openide.util.NbBundle.getMessage(TaskStatePanel.class, "TaskStatePanel.stateValue.text")); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(stateLabel)
                .addGap(18, 18, 18)
                .addComponent(stateValue, javax.swing.GroupLayout.PREFERRED_SIZE, 122, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(stateLabel)
                    .addComponent(stateValue))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel stateLabel;
    private javax.swing.JLabel stateValue;
    // End of variables declaration//GEN-END:variables
}
